var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import { useRef, useState } from "react";
import styled from "styled-components";
import axios from "axios";
import { darkgray50, gray70, redpink50, ic_common_warning_16_red, ic_common_attach_16_gray_0, tablet, ic_common_arrow_20_gray, } from "../../common";
export var Form;
(function (Form) {
    var _this = this;
    Form.Text = function (_a) {
        var title = _a.title, placeholder = _a.placeholder, validation = _a.validation, space = _a.space, type = _a.type, defaultValue = _a.defaultValue, required = _a.required, disabled = _a.disabled, onChange = _a.onChange;
        var _b = useState(defaultValue ? true : false), focus = _b[0], setFocus = _b[1];
        var inputRef = useRef(null);
        var titleRef = useRef(null);
        var handleFocus = function () {
            setFocus(true);
        };
        var handleBlur = function () {
            if (inputRef.current && !inputRef.current.value) {
                setFocus(false);
            }
        };
        return (_jsxs(Container, __assign({ space: space }, { children: [title && (_jsx(Title, __assign({ ref: titleRef, theme: { focus: focus, required: required } }, { children: title }), void 0)),
                _jsx(Input, { ref: inputRef, type: type, name: title, placeholder: focus ? placeholder : "", defaultValue: defaultValue, onFocus: handleFocus, onBlur: handleBlur, onChange: onChange, disabled: disabled, autoComplete: "off" }, void 0),
                validation && validation.show && (_jsx(InvalidMessage, { children: validation.invalidMessage }, void 0))] }), void 0));
    };
    Form.Select = function (_a) {
        var title = _a.title, options = _a.options, validation = _a.validation, space = _a.space, defaultValue = _a.defaultValue, required = _a.required, onClick = _a.onClick, onClose = _a.onClose, show = _a.show;
        var _b = useState(defaultValue !== null && defaultValue !== void 0 ? defaultValue : ""), selected = _b[0], setSelected = _b[1];
        var optionRef = useRef(null);
        var handleEvent = function (e) {
            e.stopPropagation();
            onClick();
        };
        var handleClick = function (value) {
            setSelected(value);
            console.log("?!");
            onClose();
        };
        return (_jsxs(Container, __assign({ space: space, onClick: handleEvent }, { children: [title && (_jsx(Title, __assign({ theme: { focus: selected === "" ? false : true, required: required } }, { children: title }), void 0)),
                _jsx(InputSelect, { theme: { clicked: show }, name: title, value: selected, disabled: true, autoComplete: "off" }, void 0),
                show && (_jsx(Options, __assign({ ref: optionRef }, { children: options === null || options === void 0 ? void 0 : options.map(function (option, index) {
                        return (_jsx(Option, __assign({ onClick: function () { return handleClick(option.value); } }, { children: option.value }), index));
                    }) }), void 0)),
                validation && validation.show && (_jsx(InvalidMessage, { children: validation.invalidMessage }, void 0))] }), void 0));
    };
    Form.File = function (_a) {
        var title = _a.title, required = _a.required;
        var _b = useState(false), toggle = _b[0], setToggle = _b[1];
        var _c = useState(), value = _c[0], setValue = _c[1];
        var handleChange = function (e) { return __awaiter(_this, void 0, void 0, function () {
            var target, formData, data, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        e.preventDefault();
                        target = e.target;
                        if (!target.files[0]) return [3 /*break*/, 6];
                        if (!(target.files[0].name.split(".")[1] === "pdf")) return [3 /*break*/, 5];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        formData = new FormData();
                        formData.append("file", target.files[0]);
                        return [4 /*yield*/, axios.post("/api/files", formData)];
                    case 2:
                        data = (_a.sent()).data;
                        setValue(data.url);
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _a.sent();
                        alert("파일 업로드 실패");
                        console.log(error_1.response.data);
                        return [3 /*break*/, 4];
                    case 4: return [3 /*break*/, 6];
                    case 5:
                        alert("올바른 확장자가 아닙니다.");
                        _a.label = 6;
                    case 6: return [2 /*return*/];
                }
            });
        }); };
        return (_jsxs(FileContainer, { children: [title && _jsx(Title, __assign({ theme: { focus: true, required: required } }, { children: title }), void 0),
                _jsxs(ButtonGroup, { children: [_jsx(ToggleButton, __assign({ type: "button", theme: { active: !toggle }, onClick: function () { return setToggle(false); } }, { children: "\uD30C\uC77C \uCCA8\uBD80" }), void 0),
                        _jsx(ToggleButton, __assign({ type: "button", theme: { active: toggle }, onClick: function () { return setToggle(true); } }, { children: "\uB9C1\uD06C \uC785\uB825" }), void 0)] }, void 0),
                toggle ? (_jsx(Input, { name: title, placeholder: "https://" }, void 0)) : (_jsxs(_Fragment, { children: [_jsx(Input, __assign({ as: "label", htmlFor: title }, { children: value !== null && value !== void 0 ? value : title + " \uCCA8\uBD80 (PDF\uD615\uC2DD, \uCD5C\uB300 10MB)" }), void 0),
                        _jsx(InputFile, { type: "file", id: title, name: title, accept: ".pdf", value: value, onChange: handleChange }, void 0)] }, void 0))] }, void 0));
    };
})(Form || (Form = {}));
var Container = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  position: relative;\n  width: 100%;\n  height: 52px;\n  padding: 20px 0;\n  margin: ", ";\n"], ["\n  position: relative;\n  width: 100%;\n  height: 52px;\n  padding: 20px 0;\n  margin: ", ";\n"])), function (_a) {
    var space = _a.space;
    return space !== null && space !== void 0 ? space : "";
});
var FileContainer = styled(Container)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  height: 121px;\n  label {\n    color: ", ";\n    cursor: pointer;\n\n    &:before {\n      content: ", ";\n      margin-right: 3px;\n    }\n  }\n"], ["\n  height: 121px;\n  label {\n    color: ", ";\n    cursor: pointer;\n\n    &:before {\n      content: ", ";\n      margin-right: 3px;\n    }\n  }\n"])), gray70, ic_common_attach_16_gray_0);
var Input = styled.input(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  position: absolute;\n  width: inherit;\n  font-size: 22px;\n  padding: 6px 0 16px;\n  outline: none;\n  border: none;\n  border-bottom: 2px solid #f5f7f7;\n  background: none;\n\n  &:focus {\n    border-bottom-color: ", ";\n  }\n\n  @media (max-width: ", ") {\n    font-size: 16px;\n  }\n"], ["\n  position: absolute;\n  width: inherit;\n  font-size: 22px;\n  padding: 6px 0 16px;\n  outline: none;\n  border: none;\n  border-bottom: 2px solid #f5f7f7;\n  background: none;\n\n  &:focus {\n    border-bottom-color: ", ";\n  }\n\n  @media (max-width: ", ") {\n    font-size: 16px;\n  }\n"])), redpink50, tablet);
var InputSelect = styled(Input)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  caret-color: transparent;\n  &:disabled {\n    cursor: pointer;\n  }\n\n  border-bottom-color: ", ";\n\n  &:after {\n    content: ", ";\n    display: block;\n    position: absolute;\n    right: 0;\n  }\n"], ["\n  caret-color: transparent;\n  &:disabled {\n    cursor: pointer;\n  }\n\n  border-bottom-color: ", ";\n\n  &:after {\n    content: ", ";\n    display: block;\n    position: absolute;\n    right: 0;\n  }\n"])), function (_a) {
    var theme = _a.theme;
    return theme.clicked && redpink50;
}, ic_common_arrow_20_gray);
var InputFile = styled(Input)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  display: none;\n"], ["\n  display: none;\n"])));
var Options = styled.ul(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n  font-size: 14px;\n  position: absolute;\n  top: calc(100% - 20px);\n  width: 100%;\n  max-height: 300px;\n  background: #fff;\n  border-radius: 0px 0px 5px 5px;\n  box-shadow: rgb(0 0 0 / 20%) 0px 2px 5px 0px;\n  z-Index: 1;\n\n  margin: 0;\n  padding: 0;\n  \n  overflow-y: scroll;\n  list-style-type: none;\n\n  @media(max-width: ", ") {\n    top: calc(100% - 18px);\n  }\n}"], ["\n  font-size: 14px;\n  position: absolute;\n  top: calc(100% - 20px);\n  width: 100%;\n  max-height: 300px;\n  background: #fff;\n  border-radius: 0px 0px 5px 5px;\n  box-shadow: rgb(0 0 0 / 20%) 0px 2px 5px 0px;\n  z-Index: 1;\n\n  margin: 0;\n  padding: 0;\n  \n  overflow-y: scroll;\n  list-style-type: none;\n\n  @media(max-width: ", ") {\n    top: calc(100% - 18px);\n  }\n}"])), tablet);
var Option = styled.li(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n  padding: 12px;\n  &:hover {\n    background: #f5f7f7;\n  }\n"], ["\n  padding: 12px;\n  &:hover {\n    background: #f5f7f7;\n  }\n"])));
var Title = styled.span(templateObject_8 || (templateObject_8 = __makeTemplateObject(["\n  ", "\n"], ["\n  ",
    "\n"])), function (_a) {
    var theme = _a.theme;
    return "\n        position: absolute;\n        font-size: " + (theme.focus ? "13px" : "22px") + ";\n        top: 0;\n        left: 0;\n        color: " + (theme.focus ? darkgray50 : gray70) + ";\n        transition: 0.2s;\n        transform: translateY(" + (theme.focus ? "0" : "34px") + ");\n        " + (theme.required
        ? "&:after {\n            content: \"*\";\n            position: absolute;\n            top: -0.2em;\n            right: -0.6em;\n            color: " + redpink50 + ";\n          }"
        : "") + "\n\n        @media(max-width: " + tablet + "){\n          font-size:" + (theme.focus ? "13px" : "16px") + ";\n        }\n    ";
});
var InvalidMessage = styled.span(templateObject_9 || (templateObject_9 = __makeTemplateObject(["\n  position: absolute;\n  display: inline-flex;\n  bottom: 0;\n  left: 0;\n  color: ", ";\n  font-size: 12px;\n  &:before {\n    content: \"\";\n    width: 16px;\n    height: 16px;\n    margin-right: 4px;\n    background: no-repeat center/cover ", ";\n  }\n"], ["\n  position: absolute;\n  display: inline-flex;\n  bottom: 0;\n  left: 0;\n  color: ", ";\n  font-size: 12px;\n  &:before {\n    content: \"\";\n    width: 16px;\n    height: 16px;\n    margin-right: 4px;\n    background: no-repeat center/cover ", ";\n  }\n"])), redpink50, ic_common_warning_16_red);
var ButtonGroup = styled.div(templateObject_10 || (templateObject_10 = __makeTemplateObject(["\n  position: relative;\n  display: flex;\n  width: 100%;\n  height: 50px;\n  border-radius: 6px;\n  border: solid 1px #e2e7ed;\n  margin: 10px 0;\n\n  @media (max-width: ", ") {\n    height: 40px;\n  }\n"], ["\n  position: relative;\n  display: flex;\n  width: 100%;\n  height: 50px;\n  border-radius: 6px;\n  border: solid 1px #e2e7ed;\n  margin: 10px 0;\n\n  @media (max-width: ", ") {\n    height: 40px;\n  }\n"])), tablet);
var ToggleButton = styled.button(templateObject_11 || (templateObject_11 = __makeTemplateObject(["\n  position: absolute;\n  width: 50%;\n  height: 52px;\n  top: -1px;\n  font-size: 16px;\n  line-height: 0.75;\n  letter-spacing: -0.5px;\n  background: none;\n  color: ", ";\n  border-radius: 6px;\n  border: solid 1px ", ";\n\n  &: first-child {\n    left: 0;\n  }\n\n  &: last-child {\n    right: 0;\n  }\n\n  @media (max-width: ", ") {\n    height: 42px;\n  }\n"], ["\n  position: absolute;\n  width: 50%;\n  height: 52px;\n  top: -1px;\n  font-size: 16px;\n  line-height: 0.75;\n  letter-spacing: -0.5px;\n  background: none;\n  color: ", ";\n  border-radius: 6px;\n  border: solid 1px ", ";\n\n  &: first-child {\n    left: 0;\n  }\n\n  &: last-child {\n    right: 0;\n  }\n\n  @media (max-width: ", ") {\n    height: 42px;\n  }\n"])), function (_a) {
    var theme = _a.theme;
    return (theme.active ? redpink50 : darkgray50);
}, function (_a) {
    var theme = _a.theme;
    return (theme.active ? redpink50 : "transparent");
}, tablet);
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9, templateObject_10, templateObject_11;
